export declare const versions: {
    0: string;
    1: string;
    2: string;
    x: string;
};
export declare const Suppliers: string[];
export declare const prefix = "_zl_";
export declare type Device = {
    name?: string;
    localName?: string;
    advertisData?: ArrayBuffer;
    advertisString?: string;
    blueId?: string;
    deviceId?: string;
    serviceId?: string;
    characteristicId?: string;
    ecsNo?: string;
    RSSI?: number | string;
    supplier?: 'ZL';
    version?: 'ZL1' | 'ZL2' | 'YX' | 'TS';
    auth?: boolean;
    write?: boolean;
    connected?: boolean;
    state?: 0 | 1;
};
export declare class BlueDevice {
    name: string;
    blueId: string;
    deviceId: string;
    serviceId: string;
    characteristicId: string;
    localName: string;
    RSSI: string | number;
    ecsNo: string;
    advertisData: ArrayBuffer | unknown;
    advertisString: string;
    supplier: string;
    auth: boolean;
    write: boolean;
    connected: boolean;
    isValid: boolean;
    process: boolean;
    processStartTime: number;
    version: string;
    state: number;
    constructor(device: Device);
    setSupplier(s: string): void;
    setName(n: string): void;
    setState(s: 0 | 1): void;
    setAdvertisString(a: string): void;
    setVersion(v: string): void;
    setIsValid(i: boolean): void;
    setConnected(c: boolean): void;
    setWrite(w: boolean): void;
    setAuth(a: boolean): void;
    setBlueId(bId: string): void;
    setServiceId(serviceId: string): void;
    setCharacteristicId(characteristicId: string): void;
    setProcess(process: boolean): void;
    getProcess(): boolean;
    decrypt(): void;
    encrypt(): boolean;
    private parseName;
    private parseAdvertisData;
}
