"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YXBlueParse = void 0;
var CrcService_1 = require("../CrcService");
var CryptoService_1 = require("../crypto/CryptoService");
var SUFFIX = 'ef';
var YXBlueParse = /** @class */ (function () {
    function YXBlueParse() {
    }
    YXBlueParse.encrypt = function (text) {
        var enc = CryptoService_1.Crypto.encrypt(text);
        var length = enc.length / 2;
        return SUFFIX +
            '00' +
            String(Number(length).toString(16)).padStart(2, '0') +
            enc +
            CrcService_1.Crc.crc16XMode(enc, length);
    };
    YXBlueParse.decrypt = function (encryptedHex) {
        try {
            var json = CryptoService_1.Crypto.decrypt(encryptedHex);
            return JSON.parse('{"' + json.substr(json.indexOf('ZL')));
        }
        catch (e) {
            console.log(e);
            return {};
        }
    };
    return YXBlueParse;
}());
exports.YXBlueParse = YXBlueParse;
