"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.YXBlueParse2 = void 0;
// import { Crc } from "../CrcService";
// import { Crypto } from "../crypto/CryptoService"
// @ts-ignore
var crypto_js_1 = __importDefault(require("crypto-js"));
var util_1 = require("../../utils/util");
var __1 = require("../..");
var SUFFIX = 'ef';
var YXBlueParse2 = /** @class */ (function () {
    function YXBlueParse2() {
    }
    YXBlueParse2.encrypt = function (data) {
        if (typeof data === "object") {
            try {
                data = JSON.stringify(data);
            }
            catch (error) {
                console.log("encrypt error:", error);
            }
        }
        var dataHex = crypto_js_1.default.enc.Utf8.parse(data);
        var encrypted = crypto_js_1.default.AES.encrypt(dataHex, this.SECRET_KEY, {
            // iv: this.SECRET_IV,
            mode: crypto_js_1.default.mode.ECB,
            padding: crypto_js_1.default.pad.ZeroPadding
        });
        return encrypted.ciphertext.toString();
    };
    YXBlueParse2.encryptAddHeadAndCrc = function (str, totalLen) {
        return 'AB'
            + Number(totalLen / 2).toString(16).padStart(2, '0')
            + Number(str.length / 2).toString(16).padStart(2, '0')
            + str
            + __1.CrcService.crc16XMode(str).substring(2, 4)
            + 'BA';
    };
    YXBlueParse2.encryptSplit = function (data) {
        var str = YXBlueParse2.encrypt(data);
        var len = str.length;
        return (0, util_1.strSplit)(str, 30).map(function (item) { return YXBlueParse2.encryptAddHeadAndCrc(item, len); });
    };
    YXBlueParse2.decrypt = function (data) {
        try {
            var encryptedHexStr = crypto_js_1.default.enc.Hex.parse(data);
            var str = crypto_js_1.default.enc.Base64.stringify(encryptedHexStr);
            var decrypt = crypto_js_1.default.AES.decrypt(str, this.SECRET_KEY, {
                // iv: this.SECRET_IV,
                mode: crypto_js_1.default.mode.ECB,
                padding: crypto_js_1.default.pad.ZeroPadding
            });
            var decryptedStr = decrypt.toString(crypto_js_1.default.enc.Utf8);
            return JSON.parse(decryptedStr.toString());
        }
        catch (e) {
            console.log("encrypt error:", e);
            return {};
        }
    };
    YXBlueParse2.SECRET_KEY = crypto_js_1.default.enc.Utf8.parse("1917171412171900");
    return YXBlueParse2;
}());
exports.YXBlueParse2 = YXBlueParse2;
