import { Version, DeviceDetail } from "./Version";
import { Methods, PickDetailType, PickDetail, FindOrDeleteDetail, SetWheelPerimeterDetail } from '../BlueService';
export declare const G_PWD = "03000101C030";
export declare class CommonVersion extends Version {
    handle(method: Methods, detail: PickDetailType): void;
    decodeBlueRsaData(data: string, isPassword?: boolean): string | boolean;
    encodeBlueRsaData(data: string): string[];
    /**
     *
     * @param o password
     * @param cmd  start
     * @param pid  pid
     * @param code command
     * @param data content
     * @param isPassword
     * @returns start + pid + len + command + data[authcode + data]
     */
    encodeStr(o: string, cmd?: string, pid?: string, code?: string, data?: string, isPassword?: boolean): string | boolean;
    auth(uuid: string): void;
    handlePassword(password: string): void;
    handleResult(res: string): void;
    handleData(uuid: string): void;
    /**
     * 自定义下发
     * @param code
     * @param data
     */
    send(code: string, data?: string): void;
    /**
     * 开机
     * @param detail
     */
    turnOn(detail: PickDetail): void;
    /**
     * 关机
     * @param detail = null
     */
    turnOff(detail?: null): void;
    /**
     * 采集人脸特征
     * @param detail
     */
    pickUpFace(detail: PickDetail): void;
    /**
     * 删除人脸特征信息
     * @param detail
     */
    deleteFace(detail: FindOrDeleteDetail): void;
    /**
     * 清楚人脸特征信息
     * @param detail = null
     */
    clearFace(detail?: null): void;
    /**
     * 查询指定人脸特征信息
     * @param detail
     */
    findFace(detail: FindOrDeleteDetail): void;
    /**
     * 采集指纹特征
     * @param detail
     */
    pickUpFinger(detail: PickDetail): void;
    /**
     * 删除指纹特征信息
     * @param detail
     */
    deleteFinger(detail: FindOrDeleteDetail): void;
    /**
     * 清楚人脸特征信息
     * @param detail = null
     */
    clearFinger(detail?: null): void;
    /**
     * 查询指定指纹特征信息
     * @param detail
     */
    findFinger(detail: FindOrDeleteDetail): void;
    /**
     * 获取设备所有指纹特征信息
     * @param detail = null
     */
    fetchFingers(detail?: null): void;
    addDevice(detail: DeviceDetail): void;
    deleteDevice(detail: DeviceDetail): void;
    getDevices(): void;
    getDeviceMac(detail: DeviceDetail): void;
    getDevicesOnline(): void;
    devicePickFinger(detail: DeviceDetail): void;
    deviceDeleteFinger(detail: DeviceDetail): void;
    deviceClearFinger(detail: DeviceDetail): void;
    deviceGetFinger(detail: DeviceDetail): void;
    deviceSetWheelPerimeter(detail: SetWheelPerimeterDetail): void;
}
