"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonVersion = exports.G_PWD = void 0;
var ZLBlueParse_1 = require("../parse/ZLBlueParse");
var TSBlueParse_1 = require("../parse/TSBlueParse");
var util_1 = require("../../utils/util");
var Version_1 = require("./Version");
var error_1 = __importDefault(require("../../error"));
var Methods_1 = __importDefault(require("../Methods"));
var BlueParse_1 = require("../utils/BlueParse");
// 指令
// - 主机指令
var COMMON_CMD = '00';
var PASSWORD_CMD = '01';
var AUTH_CMD = '02';
var START_CMD = '31';
var OFF_CMD = '32';
var PICK_FACE_CMD = '41';
var DEL_FACE_CMD = '42';
var CLEAR_FACE_CMD = '43';
var GET_FACE_CMD = '44';
// const TAKE_PHOTO_CMD = '45';
// const GET_FACE_M_CMD = '46';
// const UP_FACE_M_CMD = '47';
var PICK_FINGER_CMD = '51';
var DEL_FINGER_CMD = '52';
var CLEAR_FINGER_CMD = '53';
var GET_FINGER_CMD = '54';
var FETCH_FINGER_CMD = '55';
// -- 添加外设
var ADD_DEVICE_CMD = '61';
var DEL_DEVICE_CMD = '62';
var GET_DEVICES_CMD = '63';
var GET_DEVICE_MAC_CMD = '64';
var T_MESSAGE_TO_DEVICE_CMD = '65';
var GET_DEVICES_ONLINE_CMD = '66';
// - 外设指令
var D_PICK_FINGER_CMD = '05';
var D_DEL_FINGER_CMD = '06';
var D_CLEAR_FINGER_CMD = '07';
var D_GET_FINGER_CMD = '08';
// -- 速度外设
var D_SET_WHEEL_P_CMD = '09'; // 设置速度外设轮子周长
// 主机直接指令
var CODE_METHODS = (_a = {},
    _a[COMMON_CMD] = Methods_1.default.NONE_METHOD,
    _a[PASSWORD_CMD] = Methods_1.default.PASSWORD,
    _a[AUTH_CMD] = Methods_1.default.AUTH,
    _a[START_CMD] = Methods_1.default.ON,
    _a[OFF_CMD] = Methods_1.default.OFF,
    _a[PICK_FACE_CMD] = Methods_1.default.PICK_FACE,
    _a[DEL_FACE_CMD] = Methods_1.default.DEL_FACE,
    _a[CLEAR_FACE_CMD] = Methods_1.default.CLEAR_FACE,
    _a[GET_FACE_CMD] = Methods_1.default.GET_FACE,
    _a[PICK_FINGER_CMD] = Methods_1.default.PICK_FINGER,
    _a[DEL_FINGER_CMD] = Methods_1.default.DEL_FINGER,
    _a[CLEAR_FINGER_CMD] = Methods_1.default.CLEAR_FINGER,
    _a[GET_FINGER_CMD] = Methods_1.default.GET_FINGER,
    _a[FETCH_FINGER_CMD] = Methods_1.default.FETCH_FINGER,
    _a[ADD_DEVICE_CMD] = Methods_1.default.ADD_DEVICE,
    _a[DEL_DEVICE_CMD] = Methods_1.default.DEL_DEVICE,
    _a[GET_DEVICES_CMD] = Methods_1.default.GET_DEVICES,
    _a[GET_DEVICE_MAC_CMD] = Methods_1.default.GET_DEVICE_MAC,
    _a[T_MESSAGE_TO_DEVICE_CMD] = Methods_1.default.T_MESSAGE_TO_DEVICE,
    _a[GET_DEVICES_ONLINE_CMD] = Methods_1.default.GET_DEVICES_ONLINE,
    _a);
// 外设对应指令
var DEVICE_CODE_METHODS = (_b = {},
    _b[D_PICK_FINGER_CMD] = Methods_1.default.D_PICK_FINGER,
    _b[D_DEL_FINGER_CMD] = Methods_1.default.D_DEL_FINGER,
    _b[D_CLEAR_FINGER_CMD] = Methods_1.default.D_CLEAR_FINGER,
    _b[D_GET_FINGER_CMD] = Methods_1.default.D_GET_FINGER,
    _b[D_SET_WHEEL_P_CMD] = Methods_1.default.D_SET_WHEEL_P,
    _b);
var SUCCESS_STATUS = '00';
var RES_STATUS = {
    '00': '成功',
    '01': '指令不存在',
    '02': 'CRC校验失败',
    '04': '认证失败',
    '05': '无效ID',
    '06': '设备内存已满',
    '07': '无效指令',
    '08': '获取人脸超时',
    '09': '外设添加失败',
    '0a': '非法操作',
    '0b': '蓝牙跟4G模组交互超时',
    '0c': '蓝牙跟指纹模组交互超时',
    '0d': '未检测到手指',
    '0e': '指纹采集失败',
};
// const PackageLen: number = 30;
exports.G_PWD = '03000101C030';
var Parse = {
    'ZL2': ZLBlueParse_1.ZLBlueParse,
    'TS': TSBlueParse_1.TSBlueParse,
};
var CommonVersion = /** @class */ (function (_super) {
    __extends(CommonVersion, _super);
    function CommonVersion() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // constructor(fn: Function) {
    //     super(fn);
    // }
    CommonVersion.prototype.handle = function (method, detail) {
        if (method === Methods_1.default.NONE_METHOD) {
            // TODO:: 没有任何指向的时候
            return;
        }
        // @ts-ignore
        if (!this[method]) {
            // TODO:: 不支持的功能
            return;
        }
        // @ts-ignore
        if ([Methods_1.default.ON, Methods_1.default.PICK_FACE, Methods_1.default.PICK_FINGER, Methods_1.default.D_PICK_FINGER].includes(method)) {
            //  @ts-ignore
            if (!detail || !detail.name) {
                // TODO:: 参数不能为空
                if (this.fail) {
                    this.fail(error_1.default.encodePassError, '姓名不能为空');
                }
                return;
            }
            // @ts-ignore
            if (detail.mobile && !(0, util_1.pregMobile)(detail.mobile)) {
                // TODO:: 手机号格式不正确
                if (this.fail) {
                    this.fail(error_1.default.encodePassError, '手机号格式不正确');
                }
                return;
            }
            // @ts-ignore
            if (detail.expire && !(0, util_1.pregExpire)(detail.expire)) {
                // TODO:: 有效日期格式不正确 [2000-01-01 - 2099-12-31]
                if (this.fail) {
                    this.fail(error_1.default.encodePassError, '有效日期格式不正确 [2000-01-01 - 2099-12-31]');
                }
                return;
            }
        }
        // @ts-ignore
        this[method](detail);
    };
    CommonVersion.prototype.decodeBlueRsaData = function (data, isPassword) {
        if (isPassword === void 0) { isPassword = false; }
        var rsa = [];
        try {
            var length = isPassword ? data.length / 8 : parseInt(data.substring(4, 6), 16) / 4;
            var i = 0;
            var position = [];
            while (i < length) {
                var start = (isPassword ? 0 : 6) + (i * 8);
                var temp = (Parse[this.version]).rasEncryption(BlueParse_1.BlueParse.dataConversion(data.substring(start, start + 8)));
                position.push([Number(temp.substring(0, 1)), Number(temp.substring(1, 2))]);
                i++;
            }
            while (position.length) {
                var temp = position.pop();
                if (temp) {
                    if (temp[0] > 8 || temp[1] > 8) {
                        console.info('密码错误', temp);
                    }
                    else {
                        rsa.push(((Parse[this.version]).PasswordTable[temp[0]][temp[1]]).charCodeAt(0).toString(16).padStart(2, '0'));
                    }
                }
                else {
                    console.log('密码错误');
                }
            }
        }
        catch (err) {
            // 错误信息
            return false;
        }
        return rsa.join('');
    };
    // 通用策略
    CommonVersion.prototype.encodeBlueRsaData = function (data) {
        var length = data.length / 2;
        var i = 0;
        var strArr = [];
        while (i < length) {
            var temp = (Parse[this.version]).rasEncryptionSend(data.substring(i * 2, i * 2 + 2));
            // 高低位置反转
            strArr.push(BlueParse_1.BlueParse.dataConversion(temp));
            i++;
        }
        return strArr;
    };
    /**
     *
     * @param o password
     * @param cmd  start
     * @param pid  pid
     * @param code command
     * @param data content
     * @param isPassword
     * @returns start + pid + len + command + data[authcode + data]
     */
    CommonVersion.prototype.encodeStr = function (o, cmd, pid, code, data, isPassword) {
        if (cmd === void 0) { cmd = '03'; }
        if (pid === void 0) { pid = PASSWORD_CMD; }
        if (code === void 0) { code = ''; }
        if (data === void 0) { data = ''; }
        if (isPassword === void 0) { isPassword = false; }
        // 解密后早到对应坐标值
        var d1 = this.decodeBlueRsaData(o, isPassword);
        if (!d1) {
            return false;
        }
        var t = code + this.encodeBlueRsaData(d1).reverse().join('');
        t += data;
        var len = t.length / 2;
        var cmdLen = len.toString(16).padStart(2, '0');
        var oc = cmd + pid + cmdLen + t;
        return oc + BlueParse_1.BlueParse.getCrc16(oc, oc.length / 2);
    };
    // 设备上传的认证消息
    CommonVersion.prototype.auth = function (uuid) {
        // 10 = start(1*2) + pid(1*2) + length(1*2) + crc(2*2)
        var length = parseInt(uuid.substring(4, 6), 16) * 2 + 10;
        if (uuid.length < length) {
            // FIXME:: 蓝牙认证信息返回长度不足，请重试
            if (this.fail) {
                this.fail(error_1.default.authDataLenError, '蓝牙认证信息返回长度不足，请重试');
            }
            return;
        }
        var data = this.encodeStr(uuid.substring(0, length), '03');
        if (!data) {
            // FIXME:: 数据错误
            if (this.fail) {
                this.fail(error_1.default.encodeAuthError, '数据错误');
            }
            return;
        }
        if (this.next) {
            this.next(data, 'send', { type: Methods_1.default.AUTH });
        }
    };
    // 密码响应之后发送之前缓存的数据
    CommonVersion.prototype.handlePassword = function (password) {
        var data = this.getData();
        this.code = this.getCode();
        if (this.code) {
            var blueSendData = this.encodeStr(password, this.cmd, COMMON_CMD, this.code, data || '', true);
            if (!blueSendData) {
                // TODO:: 数据错误
                if (this.fail) {
                    this.fail(error_1.default.encodePassError, '数据错误');
                }
                return;
            }
            if (this.next) {
                this.next(blueSendData, 'send', { type: CODE_METHODS[this.code] || Methods_1.default.NONE_METHOD });
            }
        }
    };
    CommonVersion.prototype.handleResult = function (res) {
        var code = res.substring(6, 8);
        var status = res.substring(8, 10);
        if (status !== SUCCESS_STATUS) {
            // 设置处理进度为完成，非处理状态
            if (this.process) {
                this.process(false, {
                    type: CODE_METHODS[code] || code,
                    status: false,
                    process: 1,
                    message: RES_STATUS[status] || '设备反馈状态为失败'
                });
            }
            // FIXME:: 未知蓝牙错误，请重试
            if (this.fail) {
                this.fail(error_1.default.deviceStateError, status + ' : ' + (RES_STATUS[status] || '未知蓝牙错误'));
            }
            return;
        }
        if (![PASSWORD_CMD, T_MESSAGE_TO_DEVICE_CMD].includes(code)) {
            // this.connectedDevice.setLoading(false)
            // 设置处理进度为完成，非处理状态
            if (this.process) {
                this.process(false, {
                    type: CODE_METHODS[code] || code,
                    status: true,
                    process: 0,
                    message: '成功'
                });
            }
        }
        switch (code) {
            case PASSWORD_CMD: {
                var password = res.substring(10, 18);
                this.handlePassword(password);
                break;
            }
            case AUTH_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.AUTH,
                        status: true
                    });
                }
                break;
            }
            // 开机
            case START_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.ON,
                        status: true
                    });
                }
                break;
            }
            // 关机
            case OFF_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.OFF,
                        status: true
                    });
                }
                break;
            }
            // 采集人脸反馈
            case PICK_FACE_CMD: {
                var detail = this.getContent() || {};
                var faceId = parseInt(res.substring(10, 14), 16);
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.PICK_FACE,
                        detail: {
                            id: faceId,
                            name: detail.name || ''
                        }
                    });
                }
                break;
            }
            // 删除人脸反馈
            case DEL_FACE_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.DEL_FACE,
                        status: true
                    });
                }
                break;
            }
            // 清空人脸反馈
            case CLEAR_FACE_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.CLEAR_FACE,
                        status: true
                    });
                }
                break;
            }
            // 查询人脸反馈
            case GET_FACE_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.GET_FACE,
                        status: true
                    });
                }
                break;
            }
            // 采集指纹反馈
            case PICK_FINGER_CMD: {
                var detail = this.getContent() || {};
                var fingerId = parseInt(res.substring(10, 14), 16);
                // TODO:: 请求接口告诉后台你采集成功
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.PICK_FINGER,
                        detail: {
                            id: fingerId,
                            name: detail.name || ''
                        }
                    });
                }
                break;
            }
            // 删除指纹反馈
            case DEL_FINGER_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.DEL_FINGER,
                        status: true
                    });
                }
                break;
            }
            // 清空指纹反馈
            case CLEAR_FINGER_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.CLEAR_FINGER,
                        status: true
                    });
                }
                break;
            }
            // 查询指纹反馈
            case GET_FINGER_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.GET_FINGER,
                        status: true
                    });
                }
                break;
            }
            // 获取设备所有指纹反馈
            case FETCH_FINGER_CMD: {
                // TODO:: 指纹列表，待完善
                console.log('指纹列表，待完善');
                break;
            }
            // 添加外设
            case ADD_DEVICE_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.ADD_DEVICE,
                        message: res
                    });
                }
                break;
            }
            // 删除外设
            case DEL_DEVICE_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.DEL_DEVICE,
                        message: res
                    });
                }
                break;
            }
            // 获取所有外设
            case GET_DEVICES_CMD: {
                if (this.next) {
                    var count = parseInt(res.substring(10, 12), 16);
                    var data = [];
                    if (count > 0) {
                        // const devicesIdStr = res.substring(12, 12 + (8 * count))
                        for (var i = 0; i < count; i++) {
                            data.push({
                                id: BlueParse_1.BlueParse.dataConversion(res.substring(12 + (8 * i), 12 + (8 * (i + 1)))),
                                name: ''
                            });
                        }
                    }
                    this.next('', 'noSend', {
                        type: Methods_1.default.GET_DEVICES,
                        data: data
                    });
                }
                break;
            }
            // 获取所有外设
            case GET_DEVICE_MAC_CMD: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.GET_DEVICE_MAC,
                        message: res
                    });
                }
                break;
            }
            // 外设设备反馈
            case T_MESSAGE_TO_DEVICE_CMD: {
                var contentLength = parseInt(res.substring(4, 6), 16);
                var contentStart = res.substring(10, 12);
                if (contentLength <= 2) {
                    break;
                }
                if (contentStart !== '06') {
                    if (this.process) {
                        this.process(false, {
                            type: Methods_1.default.NONE_METHOD,
                            status: false,
                            process: 1,
                            message: '外设返回失败'
                        });
                    }
                    break;
                }
                var extraDeviceId = res.substring(12, 20);
                var contentCmd = res.substring(20, 22);
                if (this.process) {
                    this.process(false, {
                        type: DEVICE_CODE_METHODS[contentCmd] || Methods_1.default.NONE_METHOD,
                        status: true,
                        process: 0,
                        message: '外设处理成功'
                    });
                }
                switch (contentCmd) {
                    // 添加
                    case D_PICK_FINGER_CMD: {
                        var fStatus = parseInt(res.substring(22, 24), 16);
                        var id = fStatus === 3 ? parseInt(res.substring(26, 28), 16) : 100000;
                        // const id = parseInt(res.substring(26, 28), 16);
                        // const id = parseInt(res.substring(26, 28), 16);
                        if (this.next) {
                            this.next('', 'noSend', {
                                type: Methods_1.default.D_PICK_FINGER,
                                detail: {
                                    id: id,
                                    deviceId: extraDeviceId || ''
                                }
                            });
                        }
                        break;
                    }
                    // 删除
                    case D_DEL_FINGER_CMD: {
                        var id = parseInt(res.substring(24, 28), 16);
                        if (this.next) {
                            this.next('', 'noSend', {
                                type: Methods_1.default.D_DEL_FINGER,
                                detail: {
                                    id: id,
                                    deviceId: extraDeviceId || ''
                                }
                            });
                        }
                        break;
                    }
                    // 清空
                    case D_CLEAR_FINGER_CMD: {
                        if (this.next) {
                            this.next('', 'noSend', {
                                type: Methods_1.default.D_CLEAR_FINGER,
                                detail: {
                                    deviceId: extraDeviceId || ''
                                }
                            });
                        }
                        break;
                    }
                    // 获取所有指纹
                    case D_GET_FINGER_CMD: {
                        var ids = res.substring(24, 88);
                        console.log({ res: res, ids: ids });
                        if (this.next) {
                            this.next('', 'noSend', {
                                type: Methods_1.default.D_GET_FINGER,
                                detail: {
                                    ids: ids
                                }
                            });
                        }
                        break;
                    }
                    // TODO:: 获取所有指纹
                    case D_SET_WHEEL_P_CMD: {
                        console.log(res);
                        break;
                    }
                    default: {
                        console.log(res);
                    }
                }
                break;
            }
            case GET_DEVICES_ONLINE_CMD: {
                if (this.next) {
                    var count = parseInt(res.substring(10, 12), 16);
                    var data = [];
                    if (count > 0) {
                        // const devicesIdStr = res.substring(12, 12 + (8 * count))
                        for (var i = 0; i < count; i++) {
                            data.push({
                                id: BlueParse_1.BlueParse.dataConversion(res.substring(12 + (8 * i), 12 + (8 * (i + 1)))),
                                name: ''
                            });
                        }
                    }
                    this.next('', 'noSend', {
                        type: Methods_1.default.GET_DEVICES_ONLINE,
                        data: data
                    });
                }
                break;
            }
            default: {
                if (this.next) {
                    this.next('', 'noSend', {
                        type: code,
                        status: true,
                        message: res
                    });
                }
            }
        }
    };
    CommonVersion.prototype.handleData = function (uuid) {
        var isMultiPackage = false;
        var tempUuid = wx.getStorageSync('mtu');
        if (tempUuid) {
            isMultiPackage = true;
            uuid = tempUuid + uuid;
        }
        // auth认证
        if (/^0301[\w]{4,}$/.test(uuid)) {
            this.auth(uuid);
            return;
        }
        if (/^0307[\w]{8,}$/.test(uuid)) {
            var length = parseInt(uuid.substring(4, 6), 16) * 2 + 10;
            uuid = uuid.substring(0, length);
            if (uuid.length < length) {
                wx.setStorageSync('mtu', uuid);
            }
            if (isMultiPackage && uuid.length >= length) {
                wx.removeStorageSync('mtu');
            }
            // noinspection JSIgnoredPromiseFromCall
            this.handleResult(uuid);
        }
    };
    /**
     * 自定义下发
     * @param code
     * @param data
     */
    CommonVersion.prototype.send = function (code, data) {
        this.code = code;
        this.setCode(this.code);
        if (data) {
            this.setData(data);
        }
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 开机
     * @param detail
     */
    CommonVersion.prototype.turnOn = function (detail) {
        this.code = START_CMD;
        var name = (0, util_1.encodeToGb2312)(detail.name || '王二小', 20);
        // TODO:: 日期
        var expire = Math.ceil((new Date(detail.expire || '')).valueOf() / 1000).toString(16).padStart(8, '0');
        var mobile = (detail.mobile || '').substring(0, 11).padEnd(12, '0');
        this.setCode(this.code);
        this.setData(name + expire + mobile);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 关机
     * @param detail = null
     */
    CommonVersion.prototype.turnOff = function (detail) {
        if (detail === void 0) { detail = null; }
        // this._detail = detail;
        this.setCode(OFF_CMD);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 采集人脸特征
     * @param detail
     */
    CommonVersion.prototype.pickUpFace = function (detail) {
        this.setCode(PICK_FACE_CMD);
        this.setContent(detail);
        var faceId = Number(0).toString(16).padStart(4, '0');
        var name = (0, util_1.encodeToGb2312)(detail.name || '', 20);
        // TODO:: 日期
        var expire = Math.ceil((new Date(detail.expire || '')).valueOf() / 1000).toString(16).padStart(8, '0');
        // 填充1 设备识别问题
        var mobile = (detail.mobile || '').substring(0, 11).padEnd(12, '1');
        this.setData(faceId + name + expire + mobile);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 删除人脸特征信息
     * @param detail
     */
    CommonVersion.prototype.deleteFace = function (detail) {
        this.setCode(DEL_FACE_CMD);
        this.setContent(detail);
        var faceId16 = Number(detail.id || 0).toString(16).padStart(4, '0');
        this.setData(faceId16);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 清楚人脸特征信息
     * @param detail = null
     */
    CommonVersion.prototype.clearFace = function (detail) {
        if (detail === void 0) { detail = null; }
        this.setCode(CLEAR_FACE_CMD);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 查询指定人脸特征信息
     * @param detail
     */
    CommonVersion.prototype.findFace = function (detail) {
        this.setCode(GET_FACE_CMD);
        this.setContent(detail);
        var faceId = Number(detail.id || 0).toString(16).padStart(4, '0');
        this.setData(faceId);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 采集指纹特征
     * @param detail
     */
    CommonVersion.prototype.pickUpFinger = function (detail) {
        console.log('采集指纹2');
        this.setCode(PICK_FINGER_CMD);
        this.setContent(detail);
        var fingerId = Number(0).toString(16).padStart(4, '0');
        var name = (0, util_1.encodeToGb2312)(detail.name || '王二小', 20);
        // TODO:: 日期
        var expire = Math.ceil((new Date(detail.expire || '')).valueOf() / 1000).toString(16).padStart(8, '0');
        // 填充1 设备识别问题
        var mobile = (detail.mobile || '').substring(0, 11).padEnd(12, '1');
        this.setData(fingerId + name + expire + mobile);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 删除指纹特征信息
     * @param detail
     */
    CommonVersion.prototype.deleteFinger = function (detail) {
        this.setCode(DEL_FINGER_CMD);
        this.setContent(detail);
        var fingerId16 = Number(detail.id || 0).toString(16).padStart(4, '0');
        this.setData(fingerId16);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 清楚人脸特征信息
     * @param detail = null
     */
    CommonVersion.prototype.clearFinger = function (detail) {
        if (detail === void 0) { detail = null; }
        this.setCode(CLEAR_FINGER_CMD);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 查询指定指纹特征信息
     * @param detail
     */
    CommonVersion.prototype.findFinger = function (detail) {
        this.setCode(GET_FINGER_CMD);
        this.setContent(detail);
        var fingerId = Number(detail.id || 0).toString(16).padStart(4, '0');
        this.setData(fingerId);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    /**
     * 获取设备所有指纹特征信息
     * @param detail = null
     */
    CommonVersion.prototype.fetchFingers = function (detail) {
        if (detail === void 0) { detail = null; }
        this.setCode(FETCH_FINGER_CMD);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    CommonVersion.prototype.addDevice = function (detail) {
        var _a;
        this.setCode(ADD_DEVICE_CMD);
        this.setContent(detail);
        // const faceId = Number(detail.id || 0).toString(16).padStart(4, '0')
        // (Parse[this.version]).dataConversion(detail.deviceId.padStart(8, '0'))
        // 高低位反转
        var data = BlueParse_1.BlueParse.dataConversion(detail.deviceId.padStart(8, '0'))
            + (((_a = detail.macAddress) === null || _a === void 0 ? void 0 : _a.padStart(12, '0')) || '000000000000');
        this.setData(data);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    CommonVersion.prototype.deleteDevice = function (detail) {
        this.setCode(DEL_DEVICE_CMD);
        this.setContent(detail);
        // const faceId = Number(detail.id || 0).toString(16).padStart(4, '0')
        var data = BlueParse_1.BlueParse.dataConversion(detail.deviceId.padStart(8, '0'));
        this.setData(data);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    CommonVersion.prototype.getDevices = function () {
        this.setCode(GET_DEVICES_CMD);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    CommonVersion.prototype.getDeviceMac = function (detail) {
        this.setCode(GET_DEVICE_MAC_CMD);
        this.setContent(detail);
        // const faceId = Number(detail.id || 0).toString(16).padStart(4, '0')
        var data = BlueParse_1.BlueParse.dataConversion(detail.deviceId.padStart(8, '0'));
        this.setData(data);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    // 获取外设在线设备ID
    CommonVersion.prototype.getDevicesOnline = function () {
        this.setCode(GET_DEVICES_ONLINE_CMD);
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    // 外设下发
    CommonVersion.prototype.devicePickFinger = function (detail) {
        this.setCode(T_MESSAGE_TO_DEVICE_CMD);
        this.setContent(detail);
        // const faceId = Number(detail.id || 0).toString(16).padStart(4, '0')
        var data = '06' + BlueParse_1.BlueParse.dataConversion(detail.deviceId.padStart(8, '0')) +
            D_PICK_FINGER_CMD + '03' + D_PICK_FINGER_CMD + '0000';
        this.setData(data + BlueParse_1.BlueParse.getCrc16(data, data.length / 2));
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    CommonVersion.prototype.deviceDeleteFinger = function (detail) {
        this.setCode(T_MESSAGE_TO_DEVICE_CMD);
        this.setContent(detail);
        var id = Number(detail.id || 0).toString(16).padStart(4, '0');
        var data = '06' + BlueParse_1.BlueParse.dataConversion(detail.deviceId.padStart(8, '0')) +
            D_DEL_FINGER_CMD + '03' + D_DEL_FINGER_CMD + id;
        this.setData(data + BlueParse_1.BlueParse.getCrc16(data, data.length / 2));
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    CommonVersion.prototype.deviceClearFinger = function (detail) {
        this.setCode(T_MESSAGE_TO_DEVICE_CMD);
        this.setContent(detail);
        var data = '06' + BlueParse_1.BlueParse.dataConversion(detail.deviceId.padStart(8, '0')) +
            D_CLEAR_FINGER_CMD + '03' + D_CLEAR_FINGER_CMD + '0000';
        this.setData(data + BlueParse_1.BlueParse.getCrc16(data, data.length / 2));
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    CommonVersion.prototype.deviceGetFinger = function (detail) {
        this.setCode(T_MESSAGE_TO_DEVICE_CMD);
        this.setContent(detail);
        var data = '06' + BlueParse_1.BlueParse.dataConversion(detail.deviceId.padStart(8, '0')) + D_GET_FINGER_CMD + '03' + D_GET_FINGER_CMD + '0000';
        this.setData(data + BlueParse_1.BlueParse.getCrc16(data, data.length / 2));
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    // 设置轮胎直径
    CommonVersion.prototype.deviceSetWheelPerimeter = function (detail) {
        this.setCode(T_MESSAGE_TO_DEVICE_CMD);
        this.setContent(detail);
        var data = '06' + BlueParse_1.BlueParse.dataConversion(detail.deviceId.padStart(8, '0')) + D_SET_WHEEL_P_CMD + '05' + D_SET_WHEEL_P_CMD + (0, util_1.floatToHex32)(detail.wheelPerimeter);
        this.setData(data + BlueParse_1.BlueParse.getCrc16(data, data.length / 2));
        if (this.next) {
            this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
        }
    };
    return CommonVersion;
}(Version_1.Version));
exports.CommonVersion = CommonVersion;
