import type { Config, ProcessDetail } from '../BlueService';
declare type ProcessVFn = (process: boolean, detail: ProcessDetail) => void;
declare type FailVFn = (code: number, message: string) => void;
declare type NextFn = (str: any, type?: any, detail?: any) => void;
declare type DeviceHooks = {
    fail?: FailVFn;
    next?: NextFn;
    process?: ProcessVFn;
};
export declare type DeviceDetail = {
    deviceId: string;
    macAddress?: string;
    id?: string;
};
export declare class Version {
    cmd: string;
    code: string;
    data: string;
    content: {};
    version: string;
    static SendData: string;
    protected config: Config;
    protected fail?: FailVFn;
    protected next?: NextFn;
    protected process?: ProcessVFn;
    constructor(hooks: DeviceHooks, config: Config, version: string);
    setVersion(version: string): void;
    setConfig(config: Config): void;
    setCode(code: string): void;
    getCode(): string;
    setData(data: string): void;
    getData(): string;
    setContent(content: any): void;
    getContent(): any;
    setState(state: any): void;
    getState(): any;
}
export {};
