"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Version = void 0;
var CMD = '03';
var Version = /** @class */ (function () {
    function Version(hooks, config, version) {
        var _this = this;
        this.cmd = CMD;
        this.code = '';
        this.data = '';
        this.content = '';
        this.version = 'ZL2';
        this.config = {};
        this.setConfig(config);
        this.setVersion(version);
        Object.keys(hooks).forEach(function (method) {
            if (hooks[method]) {
                // @ts-ignore
                _this[method] = hooks[method];
            }
        });
    }
    Version.prototype.setVersion = function (version) {
        this.version = version;
    };
    Version.prototype.setConfig = function (config) {
        this.config = config;
    };
    // 设置指令code
    Version.prototype.setCode = function (code) {
        this.code = code;
        wx.setStorageSync(this.config.storagePrefix + 'b:code', code);
    };
    // 获取指令code
    Version.prototype.getCode = function () {
        this.code = wx.getStorageSync(this.config.storagePrefix + 'b:code') || '';
        wx.removeStorageSync(this.config.storagePrefix + 'b:code');
        return this.code;
    };
    Version.prototype.setData = function (data) {
        this.data = data;
        wx.setStorageSync(this.config.storagePrefix + 'b:data', data);
    };
    Version.prototype.getData = function () {
        this.data = wx.getStorageSync(this.config.storagePrefix + 'b:data') || '';
        wx.removeStorageSync(this.config.storagePrefix + 'b:data');
        return this.data;
    };
    Version.prototype.setContent = function (content) {
        this.content = content;
        wx.setStorageSync(this.config.storagePrefix + 'b:content', content);
    };
    Version.prototype.getContent = function () {
        this.content = wx.getStorageSync(this.config.storagePrefix + 'b:content');
        return this.content;
    };
    Version.prototype.setState = function (state) {
        wx.setStorageSync(this.config.storagePrefix + 'yx:state', state);
    };
    // 获取指令code
    Version.prototype.getState = function () {
        return wx.getStorageSync(this.config.storagePrefix + 'yx:state');
    };
    return Version;
}());
exports.Version = Version;
