"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.YXVersion = void 0;
var YXBlueParse2_1 = require("../parse/YXBlueParse2");
var util_1 = require("../../utils/util");
var Version_1 = require("./Version");
var error_1 = __importDefault(require("../../error"));
var Methods_1 = __importDefault(require("../Methods"));
var START_OFF = '{"ZL":["31","%s","%d","0","%d"]}';
var PICK_FACE_OLD = '{"ZL": ["55", "%s", "%s", "%s", "%s", "%d", "%d", "%s", "%d", "yx"]}';
// cmd, id, id_num, name, company, expire_at_t, t
var PICK_FACE = '{"ZL": ["68", "%s", "%s", "%s", "%s", "%d", "%d"]}';
var DEL_FACE_OLD = '{"ZL": ["60", "%s", "%s", "%d", "%d", "yx"]}';
// cmd,id,face_id,t
var DEL_FACE = '{"ZL": ["69", "%s", "%s", "%d"]}';
var FETCH_FACE = '{"ZL": ["61", "%s", "%s", "%d", "%d", "yx"]}';
// cmd,id,t
var CLEAR_FACE = '{"ZL": ["70", "%s", "%d"]}';
var START_OFF_CMD = 31;
var PICK_FACE_RES = 55;
// const PICK_FACE_RES = 68
var PICK_FACE_OK_OLD = 56;
var PICK_FACE_OK = 68;
var DEL_FACE_OK_OLD = 60;
// [cmd,id,result,t]
var DEL_FACE_OK = 69;
// cmd,id,result,t  | 0成功
var CLEAR_FACE_OK = 70;
var YXVersion = /** @class */ (function (_super) {
    __extends(YXVersion, _super);
    function YXVersion() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    YXVersion.prototype.handle = function (method, detail) {
        if (method === Methods_1.default.NONE_METHOD) {
            // TODO:: 没有任何指向的时候
            return;
        }
        // @ts-ignore
        if (!this[method]) {
            // TODO:: 不支持的功能
            return;
        }
        // @ts-ignore
        if ([Methods_1.default.ON, Methods_1.default.PICK_FACE, Methods_1.default.PICK_FINGER].includes(method)) {
            //  @ts-ignore
            if (!detail || !detail.name) {
                // TODO:: 参数不能为空
                return;
            }
            // @ts-ignore
            if (detail.mobile && !(0, util_1.pregMobile)(detail.mobile)) {
                // TODO:: 手机号格式不正确
                return;
            }
            // @ts-ignore
            if (detail.expire && !(0, util_1.pregExpire)(detail.expire)) {
                // TODO:: 有效日期格式不正确 [2000-01-01 - 2099-12-31]
                return;
            }
        }
        // @ts-ignore
        this[method](detail);
    };
    // ab(2) + total_length(2) + content_length(2) + content(2-30) + crc(2) + ab(2)
    YXVersion.prototype.handleData = function (uuid) {
        var data = uuid;
        var isMultiPackage = false;
        var yxdata = wx.getStorageSync('yxdata');
        var tempData = {
            data: '',
            recivedLength: 0,
            total: 0
        };
        if (yxdata) {
            try {
                tempData = JSON.parse(yxdata);
            }
            catch (e) {
                tempData = {
                    data: '',
                    recivedLength: 0,
                    total: 0
                };
            }
        }
        // 开头数据
        if (/^ab[a-zA-Z0-9]{8,}ba$/.test(uuid)) {
            var totalLength = parseInt(uuid.substring(2, 4), 16) * 2;
            var contentLength = parseInt(uuid.substring(4, 6), 16) * 2;
            // 1. total = content, 只有1包
            // 2. total > content 多包
            // 2.1 total <= all content 最后一包
            // total = content, 只有1包
            if (totalLength === contentLength) {
                data = uuid.substring(6, uuid.length - 4);
            }
            else {
                isMultiPackage = true;
                // 不是一个包
                if (tempData.total > 0 && totalLength !== tempData.total) {
                    wx.setStorageSync('yxdata', JSON.stringify({
                        data: uuid.substring(6, uuid.length - 4),
                        recivedLength: contentLength,
                        total: totalLength,
                    }));
                    return;
                }
                // 如果不是最后一包
                if (tempData.recivedLength + contentLength < totalLength) {
                    wx.setStorageSync('yxdata', JSON.stringify({
                        data: tempData.data + uuid.substring(6, uuid.length - 4),
                        recivedLength: tempData.recivedLength + contentLength,
                        total: totalLength,
                    }));
                    return;
                }
                // 是最后一包
                data = tempData.data + uuid.substring(6, uuid.length - 4);
                wx.removeStorageSync('yxdata');
            }
            this.handleResult(data);
        }
    };
    YXVersion.prototype.handleResult = function (res) {
        var oData = YXBlueParse2_1.YXBlueParse2.decrypt(res);
        if (!oData.ZL) {
            console.log(res);
            if (this.process) {
                this.process(false, {
                    type: 'none',
                    status: false,
                    process: 1,
                    message: '蓝牙信息标识错误。'
                });
            }
            if (this.fail) {
                this.fail(error_1.default.labelError, '蓝牙信息标识错误。');
            }
            return;
        }
        var data = oData.ZL;
        var cmd = data[0] || 0;
        if (!cmd) {
            console.log(res);
            if (this.process) {
                this.process(false, {
                    type: 'none',
                    status: false,
                    process: 1,
                    message: '返回CMD错误。'
                });
            }
            if (this.fail) {
                this.fail(error_1.default.cmdError, '返回CMD错误');
            }
            return;
        }
        // const ecsNo = (data[1] || '').split('').splice(-6).join('')
        // 获取存储的蓝牙参数数据
        switch (cmd) {
            // 开机|关机
            case START_OFF_CMD: {
                var state = this.getState();
                if (state !== data[2]) {
                    if (this.process) {
                        this.process(false, {
                            type: state === 1 ? 'turnOn' : 'turnOff',
                            status: false,
                            process: 1,
                            message: '失败'
                        });
                    }
                    if (this.fail) {
                        this.fail(error_1.default.operateFailError, state === 1 ? '开机失败' : '关机失败');
                    }
                    return;
                }
                if (data[2] === 1) {
                    if (this.process) {
                        this.process(false, {
                            type: Methods_1.default.ON,
                            status: true,
                            process: 0,
                            message: '开机成功'
                        });
                    }
                    if (this.next) {
                        this.next('', 'noSend', {
                            type: Methods_1.default.ON,
                            status: true
                        });
                    }
                }
                else {
                    if (this.process) {
                        this.process(false, {
                            type: Methods_1.default.OFF,
                            status: true,
                            process: 0,
                            message: '关机成功'
                        });
                    }
                    if (this.next) {
                        this.next('', 'noSend', {
                            type: Methods_1.default.OFF,
                            status: true
                        });
                    }
                }
                break;
            }
            case PICK_FACE_RES: {
                // uni.showToast({
                //
                // })
                console.log('正在采集');
                break;
            }
            case PICK_FACE_OK: {
                // [cmd,id,result,face_id,person_id,name,company,access,t]
                var detail = this.getContent() || {};
                var status = data[2] || 0;
                if (status) {
                    if (this.process) {
                        this.process(false, {
                            type: Methods_1.default.PICK_FACE,
                            status: false,
                            process: 1,
                            message: '采集失败'
                        });
                    }
                    if (this.fail) {
                        this.fail(error_1.default.pickError, '采集失败');
                    }
                    return;
                }
                var faceId = Number(data[3] || 0);
                if (this.process) {
                    this.process(false, {
                        type: Methods_1.default.PICK_FACE,
                        status: true,
                        process: 0,
                        message: '采集成功'
                    });
                }
                // TODO:: 请求接口告诉后台你采集成功
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.PICK_FACE,
                        detail: {
                            id: faceId,
                            name: detail.name || ''
                        }
                    });
                }
                break;
            }
            case DEL_FACE_OK: {
                // [cmd,id,result,t]
                var status = data[2] || 1;
                if (status) {
                    if (this.process) {
                        this.process(false, {
                            type: Methods_1.default.DEL_FACE,
                            status: false,
                            process: 1,
                            message: '删除失败'
                        });
                    }
                    if (this.fail) {
                        this.fail(error_1.default.pickError, '删除失败');
                    }
                    return;
                }
                if (this.process) {
                    this.process(false, {
                        type: Methods_1.default.DEL_FACE,
                        status: true,
                        process: 0,
                        message: '删除成功'
                    });
                }
                // const detail = this.getContent()
                // TODO::
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.DEL_FACE,
                        status: true
                    });
                }
                break;
            }
            case CLEAR_FACE_OK: {
                var status = data[2] || 1;
                if (status) {
                    if (this.process) {
                        this.process(false, {
                            type: Methods_1.default.DEL_FACE,
                            status: false,
                            process: 1,
                            message: '失败'
                        });
                    }
                    if (this.fail) {
                        this.fail(error_1.default.pickError, '清空失败');
                    }
                    return;
                }
                if (this.process) {
                    this.process(false, {
                        type: Methods_1.default.CLEAR_FACE,
                        status: true,
                        process: 0,
                        message: '成功'
                    });
                }
                // const detail = this.getContent()
                // TODO::
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.DEL_FACE,
                        status: true
                    });
                }
                break;
            }
            default: {
                if (this.process) {
                    this.process(false, {
                        type: Methods_1.default.NONE_METHOD,
                        status: false,
                        process: 1,
                        message: '未定义的类型'
                    });
                }
                console.log('暂时未定义类型', { data: data, cmd: cmd });
            }
        }
    };
    // if (mode === 'response') {
    //     this.handleData(data)
    // }
    YXVersion.prototype.turnOn = function (detail) {
        var _this = this;
        var timestamp = Math.ceil((new Date()).valueOf() / 1000);
        var ecsNo = detail.ecsNo || '866182828288282';
        var state = 1;
        this.setState(state);
        var cmd = (0, util_1.sprintf)(START_OFF, ecsNo, state, timestamp);
        YXBlueParse2_1.YXBlueParse2.encryptSplit(cmd).forEach(function (item) {
            if (_this.next) {
                _this.next(item, 'sendSingle', { type: Methods_1.default.ON });
            }
        });
    };
    YXVersion.prototype.turnOff = function (detail) {
        var _this = this;
        if (detail === void 0) { detail = {}; }
        // const bleOnState = this.connectedDevice.getOnState()
        var timestamp = Math.ceil((new Date()).valueOf() / 1000);
        var ecsNo = detail.ecsNo || '';
        var state = 0;
        this.setState(state);
        var cmd = (0, util_1.sprintf)(START_OFF, ecsNo, state, timestamp);
        YXBlueParse2_1.YXBlueParse2.encryptSplit(cmd).forEach(function (item) {
            if (_this.next) {
                _this.next(item, 'sendSingle', { type: Methods_1.default.OFF });
            }
        });
    };
    // addFace
    YXVersion.prototype.pickUpFace = function (detail) {
        var _this = this;
        this.setContent(detail);
        var timestamp = Math.ceil((new Date()).valueOf() / 1000);
        var ecsNo = detail.ecsNo || '';
        var driverNo = '412828199202023098';
        var driverName = detail.name;
        var company = detail.company || '尊敬的公司';
        var expire = Math.ceil((new Date(detail.expire || '')).valueOf() / 1000);
        var mobile = (detail.mobile || '').substring(0, 11).padEnd(11, '0');
        // cmd, id, id_num, name, company, expire_at_t, t
        var cmd = (0, util_1.sprintf)(PICK_FACE, ecsNo, driverNo, driverName, company, expire, timestamp);
        // const cmd = sprintf(PICK_FACE, ecsNo, driverName, '驾驶员', driverNo, timestamp, 0, mobile, expire)
        YXBlueParse2_1.YXBlueParse2.encryptSplit(cmd).forEach(function (item) {
            if (_this.next) {
                _this.next(item, 'sendSingle', { type: Methods_1.default.PICK_FACE });
            }
        });
    };
    YXVersion.prototype.deleteFace = function (detail) {
        var _this = this;
        var timestamp = Math.ceil((new Date()).valueOf() / 1000);
        var ecsNo = detail.ecsNo;
        // const driverNo = detail.driver_no
        var driverName = '';
        var faceId = detail.id;
        // cmd,id,face_id,t
        var cmd = (0, util_1.sprintf)(DEL_FACE, ecsNo, faceId, timestamp);
        YXBlueParse2_1.YXBlueParse2.encryptSplit(cmd).forEach(function (item) {
            if (_this.next) {
                _this.next(item, 'sendSingle', { type: Methods_1.default.DEL_FACE });
            }
        });
    };
    YXVersion.prototype.findFace = function (detail) {
        var _this = this;
        var timestamp = Math.ceil((new Date()).valueOf() / 1000);
        var ecsNo = detail.ecsNo;
        // const driverNo = detail.driver_no
        var driverName = detail.name;
        var faceId = detail.id;
        var cmd = (0, util_1.sprintf)(FETCH_FACE, ecsNo, driverName, timestamp, faceId);
        YXBlueParse2_1.YXBlueParse2.encryptSplit(cmd).forEach(function (item) {
            if (_this.next) {
                _this.next(item, 'sendSingle', { type: Methods_1.default.GET_FACE });
            }
        });
    };
    YXVersion.prototype.clearFace = function (detail) {
        var _this = this;
        var timestamp = Math.ceil((new Date()).valueOf() / 1000);
        var ecsNo = detail.ecsNo || '';
        // cmd,id,t
        var cmd = (0, util_1.sprintf)(CLEAR_FACE, ecsNo, timestamp);
        YXBlueParse2_1.YXBlueParse2.encryptSplit(cmd).forEach(function (item) {
            if (_this.next) {
                _this.next(item, 'sendSingle', { type: Methods_1.default.GET_FACE });
            }
        });
    };
    YXVersion.prototype.pickUpFinger = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.deleteFinger = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.clearFinger = function (detail) {
        if (detail === void 0) { detail = null; }
        console.log('无');
    };
    YXVersion.prototype.findFinger = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.fetchFingers = function (detail) {
        if (detail === void 0) { detail = null; }
        console.log('无');
    };
    YXVersion.prototype.addDevice = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.deleteDevice = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.getDevices = function () {
        console.log('无');
    };
    YXVersion.prototype.getDeviceMac = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.getDevicesOnline = function () {
        console.log('无');
    };
    YXVersion.prototype.devicePickFinger = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.deviceDeleteFinger = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.deviceClearFinger = function (detail) {
        console.log('无');
    };
    YXVersion.prototype.deviceGetFinger = function (detail) {
        console.log('无');
    };
    return YXVersion;
}(Version_1.Version));
exports.YXVersion = YXVersion;
