"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZL1Version = exports.G_PWD = void 0;
var ZLBlueParse_1 = require("../parse/ZLBlueParse");
var Version_1 = require("./Version");
var error_1 = __importDefault(require("../../error"));
var Methods_1 = __importDefault(require("../Methods"));
var BlueParse_1 = require("../utils/BlueParse");
exports.G_PWD = '03000131C024';
var START_CMD = '31';
var OFF_CMD = '32';
var ZL1Version = /** @class */ (function (_super) {
    __extends(ZL1Version, _super);
    function ZL1Version() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.turnOn = function (detail) {
            console.log(detail);
            _this.code = START_CMD;
            _this.setCode(_this.code);
            if (_this.next) {
                _this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
            }
        };
        _this.turnOff = function (detail) {
            if (detail === void 0) { detail = {}; }
            _this.code = OFF_CMD;
            _this.setCode(_this.code);
            if (_this.next) {
                _this.next(exports.G_PWD, 'send', { type: Methods_1.default.PASSWORD });
            }
        };
        return _this;
    }
    ZL1Version.prototype.decodeBlueRsaData = function (data, hasHead) {
        if (hasHead === void 0) { hasHead = false; }
        var length = hasHead ? parseInt(data.substring(2, 6), 16) / 4 : data.length / 8;
        var i = 0;
        var position = [];
        while (i < length) {
            var l = (hasHead ? 6 : 0) + i * 8;
            var temp = ZLBlueParse_1.ZLBlueParse.rasEncryption(BlueParse_1.BlueParse.dataConversion(data.substring(l, l + 8)));
            position.push([Number(temp.substring(0, 1)), Number(temp.substring(1, 2))]);
            i++;
        }
        var rsa = [];
        while (position.length) {
            var temp = position.pop();
            if (temp) {
                if (temp[0] > 8 || temp[1] > 8) {
                    console.info('密码错误[10]', temp);
                }
                else {
                    rsa.push((ZLBlueParse_1.ZLBlueParse.PasswordTable[temp[0]][temp[1]]).charCodeAt(0).toString(16).padStart(2, '0'));
                }
            }
            else {
                console.log('密码错误[11]');
            }
        }
        return rsa.join('');
    };
    // 通用策略
    ZL1Version.prototype.encodeBlueRsaData = function (data) {
        var length = data.length / 2;
        var i = 0;
        var strArr = [];
        while (i < length) {
            var temp = ZLBlueParse_1.ZLBlueParse.rasEncryptionSend(data.substring(i * 2, i * 2 + 2));
            // 高低位置反转
            strArr.push(BlueParse_1.BlueParse.dataConversion(temp));
            i++;
        }
        return strArr;
    };
    ZL1Version.prototype.encodeStr = function (o, cmd, HasHead, code, data) {
        if (cmd === void 0) { cmd = '01'; }
        if (HasHead === void 0) { HasHead = false; }
        if (code === void 0) { code = '31'; }
        if (data === void 0) { data = ''; }
        // return '01001866e3ea2da425fa7473a5bbb84a7bc906e5d1531722af4b4a7b04';
        var t = HasHead ? this.decodeBlueRsaData(o, HasHead) : code + this.decodeBlueRsaData(o, HasHead);
        t = this.encodeBlueRsaData(t).reverse().join('');
        t += data;
        var len = t.length / 2;
        var cmdLen = len.toString(16).padStart(4, '0');
        var oc = cmd + cmdLen + t;
        return oc + BlueParse_1.BlueParse.getCrc16(oc, oc.length / 2);
    };
    ZL1Version.prototype.handle = function (method, detail) {
        if (method === 'none') {
            // TODO:: 没有任何指向的时候
            return;
        }
        // @ts-ignore
        if (!this[method]) {
            // TODO:: 不支持的功能
            return;
        }
        if (['turnOn', 'pickUpFace', 'pickUpFinger'].includes(method)) {
            //  @ts-ignore
            if (!detail || !detail.name) {
                // TODO:: 参数不能为空
                if (this.fail) {
                    this.fail(error_1.default.paramsError, '姓名不能为空');
                }
                return;
            }
            // @ts-ignore
            if (detail.mobile && !pregMobile(detail.mobile)) {
                // TODO:: 手机号格式不正确
                if (this.fail) {
                    this.fail(error_1.default.paramsError, '手机号格式不正确');
                }
                return;
            }
            // @ts-ignore
            if (detail.expire && !pregExpire(detail.expire)) {
                // TODO:: 有效日期格式不正确 [2000-01-01 - 2099-12-31]
                if (this.fail) {
                    this.fail(error_1.default.paramsError, '有效日期格式不正确 [2000-01-01 - 2099-12-31]');
                }
                return;
            }
        }
        // @ts-ignore
        this[method](detail);
    };
    // 认证
    ZL1Version.prototype.auth = function (uuid) {
        var length = parseInt(uuid.substring(4, 6), 16) * 2 + 10;
        if (uuid.length < length) {
            if (this.fail) {
                this.fail(error_1.default.authDataLenError, '蓝牙认证信息返回长度不足，请重试');
            }
            return;
        }
        var data = this.encodeStr(uuid.substring(0, length), '01', true);
        if (this.next) {
            // 兼容写法
            this.next(data, 'noSend', { type: Methods_1.default.AUTH });
        }
    };
    ZL1Version.prototype.handlePassword = function (password) {
        var data = ZL1Version.SendData;
        this.code = this.getCode();
        var blueSendData = this.encodeStr(password, this.cmd, false, this.code, data || '');
        if (this.next) {
            this.next(blueSendData, 'send', { type: Methods_1.default.ON });
        }
    };
    ZL1Version.prototype.handleResult = function (res) {
        var state = parseInt(res.substring(6, 8), 16);
        this.data = '';
        // 设置处理进度为完成，非处理状态
        if (![1, 2].includes(state)) {
            if (this.process) {
                this.process(false, {
                    type: 'none',
                    status: false,
                    process: 1,
                    message: '设备状态返回失败'
                });
            }
        }
        // 获取存储的蓝牙参数数据
        switch (state) {
            // 开机
            case 1: {
                if (this.process) {
                    this.process(false, {
                        type: Methods_1.default.ON,
                        status: true,
                        process: 0,
                        message: '开机成功'
                    });
                }
                // TODO::请求接口，告诉后台开机成功
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.ON,
                        status: true
                    });
                }
                break;
            }
            // 关机
            case 2: {
                if (this.process) {
                    this.process(false, {
                        type: Methods_1.default.OFF,
                        status: true,
                        process: 0,
                        message: '关机成功'
                    });
                }
                if (this.next) {
                    this.next('', 'noSend', {
                        type: Methods_1.default.OFF,
                        status: true
                    });
                }
                break;
            }
        }
    };
    ZL1Version.prototype.handleData = function (uuid) {
        // 未知响应
        if (/^ffffffff\w{4,}$/.test(uuid) ||
            /^00208\w{10,}/.test(uuid) ||
            /^0304\w{10,}/.test(uuid) ||
            /^0040\w{10,}/.test(uuid) ||
            /^0842\w{10,}/.test(uuid)) {
            return;
        }
        // auth认证
        if (/^0100\w{4,}$/.test(uuid)) {
            this.auth(uuid);
            return;
        }
        // 成功响应
        if (/^0303\w{8,}$/.test(uuid) ||
            /^0300\w{8,}$/.test(uuid)) {
            var length = parseInt(uuid.substring(4, 6), 16) * 2 + 10;
            uuid = uuid.substring(0, length);
            this.handleResult(uuid);
            return;
        }
        // 新版本密文
        if (/^0501\w{10,}/.test(uuid)) {
            uuid = uuid.substring(6, 14);
            this.handlePassword(uuid);
            return;
        }
        // 获取的密文
        if (/^\w{8}/.test(uuid)) {
            this.handlePassword(uuid);
        }
    };
    return ZL1Version;
}(Version_1.Version));
exports.ZL1Version = ZL1Version;
